package appManage;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.rmi.server.ExportException;
import java.security.MessageDigest;
import java.util.*;

import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import util.ApitUtil;
import util.ConstantConfig;



@WebServlet("/index")
public class index extends HttpServlet {


	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		request.setCharacterEncoding("UTF-8");
		response.setCharacterEncoding("UTF-8");
		switch (request.getParameter("type")) {
		case "open":
			open(request, response);
			break;
		case "close":
			close(request, response);
			break;
		case "trigger":
			trigger(request, response);
			break;
		case "manage":
			manage(request, response);
			break;
		case "monitor":
			monitor(request, response);
			break;
		default:
			break;
		}
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

	/**
	 * 开启应用
	 *
	 * @return
	 * @throws IOException
	 */
	public void open(HttpServletRequest request, HttpServletResponse response) throws IOException {
		Map<String, String> map = getPostParameter(request);

		Map<String, String> resultMap = ApitUtil.verifySign(map);
		if (resultMap.get("errcode").equals("0")) {
			// TODO:与学校有关的业务逻辑

			// 为每一个学校生成一个唯一的小程序码，并提交访问链接
			String mnpQrcode = "http://weixiao.qq.com/upload/mnp_wxacode/fac9b61496923103.jpg";

			resultMap = new TreeMap();
			resultMap.put("errcode", "0");
			resultMap.put("errmsg", "ok");
			resultMap.put("mnp_qrcode", mnpQrcode);

			response.getWriter().write(mapToJson(resultMap));
		} else {
			// 返回错误信息
			response.getWriter().write(mapToJson(resultMap));
		}

	}

	/**
	 * 关闭应用
	 *
	 * @return
	 */
	public void close(HttpServletRequest request, HttpServletResponse response) throws IOException {
		Map<String, String> map = getPostParameter(request);

		Map<String, String> resultMap = ApitUtil.verifySign(map);
		if (resultMap.get("errcode").equals("0")) {

			// TODO:与学校有关的业务逻辑

			resultMap = new TreeMap();
			resultMap.put("errcode", "0");
			resultMap.put("errmsg", "ok");

			response.getWriter().write(mapToJson(resultMap));
		} else {
			// 返回错误信息
			response.getWriter().write(mapToJson(resultMap));
		}
	}

	/**
	 * 应用触发(H5)
	 *
	 * @return
	 */
	public void trigger(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String schoolCode = request.getParameter("school_code");
		String mediaId = request.getParameter("media_id");

		// 根据学校和学校主公众号生成移动端访问链接
		String redirectUrl = "https://weixiao.qq.com";

		response.sendRedirect(redirectUrl);
	}


	/**
	 * 应用后台管理
	 *
	 * @return
	 */
	public void manage(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String wxcode = request.getParameter("wxcode");
		String state = request.getParameter("state");

		// 管理后台业务逻辑，可返回页面或进行跳转
	}

	/**
	 * 应用监控
	 *
	 * @return
	 */
	public void monitor(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String echoStr = request.getParameter("echostr");

		response.getWriter().write(echoStr);
	}

	/**
	 * 获取POST参数
	 */
	public Map<String, String> getPostParameter(HttpServletRequest request) {
		Map<String, String> requestMap = new TreeMap<String, String>();

		StringBuffer data = new StringBuffer();
		String line = null;
		BufferedReader reader = null;
		try {
			reader = request.getReader();
			while (null != (line = reader.readLine())) {
				data.append(line);
			}
		} catch (IOException e) {
		}

		// 兼容旧的写法
		if (data.toString().equals("")) {
			Map<String, String[]> map = request.getParameterMap();

			for (String param : map.keySet()) {
				if (param.indexOf("school_code") != -1) {
					data = new StringBuffer(param);
				}
			}
		}

		JSONObject json = JSON.parseObject(data.toString());
		for (String key: json.keySet()) {
			requestMap.put(key, json.getString(key));
		}

		return requestMap;
	}

	/**
	 * 将map对象转化为json字符串
	 * @author batchen
	 * @param  map [description]
	 * @return     [description]
	 */
	public static String mapToJson(Map<String, String> map) {
		StringBuffer json = new StringBuffer();
		
		JSONObject jsonObject = new JSONObject();
		for (Map.Entry<String, String> entry : map.entrySet()) {
			jsonObject.put(entry.getKey(), entry.getValue());
		}

		return jsonObject.toString();
	}

}
